% To find the Bhatacharyya parameter(erasure prob) and bit-channel capacity of polar codes for BEC case. Source:
% Arikan's paper entitled "﻿Channel Polarization: A Method for Constructing Capacity-Achieving Codes for Symmetric
% Binary-Input Memoryless Channels"
clear all;
N=32;
m=log2(N);
Eps=0.4;
Wb=[Eps];
C=1-Eps;
base{1}=Wb;
SecrecyConst = 1e-3;

for level=1:m
    for index=1:2^(level-1)
        Q{2*index-1}=2*base{index} - base{index}^2;
        Q{2*index}=base{index}^2;
    end
    base=Q;
    eval(['Q' num2str(level) '= Q']);
end

%Bhatta
Zo=zeros(1,N);
for i=1:N
    Zo(i)=Q{i};
end
%Capacity
Ca=zeros(1,N);
for i=1:N
    Ca(i)=1 - Q{i}(:,1);
end

 
Z=sort(Zo);
C = sort(Ca);

for k= 1:N
    sumC(k)=sum(C(1:k));
    sumC(k)=min(1,sumC(k));
end
a = max(find(sumC<SecrecyConst))
Rate = a/N