% To find the Bhatacharyya parameter of polar codes for BEC case. Source:
% Arikan's paper entitled "﻿Channel Polarization: A Method for Constructing Capacity-Achieving Codes for Symmetric
% Binary-Input Memoryless Channels"
function [locations, Erasures] = Bhatacharyya_BEC_func(N,Eps)
m=log2(N);
Wb=[Eps];
base{1}=Wb;

for level=1:m
    for index=1:2^(level-1)
        Q{2*index-1}=2*base{index} - base{index}^2;
        Q{2*index}=base{index}^2;
    end
    base=Q;
end

%Bhatta
Zo=zeros(1,N);
for i=1:N
    Zo(i)=Q{i};
end
%Capacity
 
[Erasures, locations]=sort(Zo,'descend');

