% The Monte_carlo simulation to find the erasure probability of
% bit-channels for BEC case only.
% The algorithm has been explained in our ITW paper.
% This file can be used for any channel code given generator matrix and the order of successive cancellation decoding.
% Here we use for polar and Reed-Muller generator matrix.
clear
G=[1 0; 1 1];
prompt = 'What is the blocklength? ';
len = input(prompt)
m=log2(len);
Chose_RM_Polar = 2; % RM=1 and Polar =2

prompt = 'What is the erasure probability? ';
Pe = input(prompt)

prompt = 'What is the number of montecarlo simulation? ';
ttl=input(prompt)
fileID = fopen('resultS.txt','w');
tic
fprintf(fileID,'----------');
fprintf(fileID,'\n\n Binary Erasure Prob with prob = %f  \n',Pe);
fprintf(fileID,'\n\n 1 is RM code and 2 is Polar. This result is for = %f  \n',Chose_RM_Polar);

% Generate G_{RM}
bnc = zeros(m+1,1);
bnc(1) = 1;
bnc(2) = 1;
for i=2:m
    GN = zeros(2*size(G,1));
    acml = 0;
    for j=1:i
        for k=1:bnc(j)
            GN(2*acml+k,1:size(G,1)) = G(acml+k,:);
        end
        for k=1:bnc(j)
            GN(2*acml+bnc(j)+k,1:size(G,1)) = G(acml+k,:);
            GN(2*acml+bnc(j)+k,(size(G,1)+1):size(GN,1)) = G(acml+k,:);
        end
        acml=acml+bnc(j);
    end
    G=GN;
    for j=i:-1:1
        bnc(j+1) = bnc(j+1)+bnc(j);
    end
end

% Generate G_{polar}

G_P=[1 0;1 1];
%[Orders,~] = Bhatacharyya_BEC_func(len,Pe);
% Row permutation of G_{polar} to find bound 1 in our ITW paper
for ii=2:m
    G_P=[G_P zeros(size(G_P));G_P G_P];
end
[ G_P,B_P,F_P ] = G_generator( len );
G_P = F_P(Orders,:);


if Chose_RM_Polar ==2
    G = G_P;
end

% The algorithm is described in paper
    erasp = zeros(1,len);
    for i=1:ttl
        A=G;
        rdp=rand(1,len);
        for j=1:len
            if (rdp(j)<Pe)
                A(:,j)=zeros(len,1);
            end
        end
        tempold = rank(A(1:len,:));
        for j=1:(len-1)
            tempnew = rank(A(j+1:len,:));
            if(tempold-tempnew == 0)
                erasp(j) = erasp(j) + 1;
            end
            tempold = tempnew;
        end
        if (rank(A(len,:)) == 0)
            erasp(len) = erasp(len) + 1;
        end
        if(mod(i,100)==0) % for long simulations it save the results in a txt file
            i
            fileID = fopen('resultS2.txt','w');
            fprintf(fileID,'----------');
            fprintf(fileID,'\n\n Binary Erasure Prob with prob = %f  \n',Pe);
            fprintf(fileID,'\n\n 1 is RM code and 2 is Polar. This result is for = %f  \n',Chose_RM_Polar);
            erasp2=erasp/i;
            fprintf('Erasure probability is %f\n', Pe);
            fprintf(fileID,'\n\n Erasure probability = %f  \n',erasp2);
            fclose(fileID);
            toc
        end
    end
toc
