% The second order approximation is picked from the paper entitled
% "﻿Wiretap Channels: Nonasymptotic Fundamental Limits" Eq. 139
clear
epsil = 0.4
Cs = epsil;
delta = 10^-10;

counter = 0;
Blocklength = 10:10:1000;
Vs = epsil*(1-epsil);
for N = Blocklength
    counter = counter+1;
    R(1,counter) = Cs - sqrt(Vs/N)*qfuncinv(delta);
end
plot(Blocklength,R)
hold on
plot(Blocklength,(Cs)*ones(size(Blocklength)))
ylim([0, Cs+0.1])